#!/usr/bin/perl -w

print "<?xml version=\"1.0\"?>\n";
print "<nodeinfo>\n";
print xmlencode("hostname",`hostname`),"\n";
print xmlencode("date",`date`),"\n";
print xmlencode("time",time()),"\n";
print xmlencodeFile("redhat","/etc/redhat-release"),"\n";
print xmlencode("linux",`uname -r`),"\n";
print xmlencode("uname",`uname -a`),"\n";
print xmlencode("yum_updated",`grep Updated \`ls -1tr /var/log/yum.log*\` | tail -1`),"\n" if -r "/var/log/yum.log";
print xmlencodeFile("yum_lock","/var/lock/subsys/yum"),"\n";
print xmlencodeFile("cpuinfo","/proc/cpuinfo"),"\n";
print xmlencodeFile("meminfo","/proc/meminfo"),"\n";
print xmlencodeFile("mounts","/proc/mounts"),"\n";
print xmlencodeFile("swaps","/proc/swaps"),"\n";
print xmlencode("uptime",`uptime`),"\n";
print xmlencode("chkconfig",`/sbin/chkconfig --list | grep on`),"\n";
print xmlencode("etchosts",`grep -v ^# /etc/hosts`),"\n";
print xmlencode("etcresolvconf",`grep -v ^# /etc/resolv.conf`),"\n";
my $domainname = `domainname`; chop $domainname;
if ($domainname ne "(none)")
  {
    print xmlencode("domainname",`domainname`),"\n";
    print xmlencode("etcypconf",`grep -v ^# /etc/yp.conf`),"\n";
    print xmlencode("ypwhich",`ypwhich 2>&1`),"\n";
    my $ypserv = system "/sbin/chkconfig ypserv >& /dev/null";
    if ($ypserv == 0)
      {
        print xmlencode("ypserv",`/sbin/pidof /usr/sbin/ypserv`),"\n";
      }
  }
print xmlencode("ifconfig",`/sbin/ifconfig -a`),"\n";
print xmlencodeFile("ifcfgeth0","/etc/sysconfig/network-scripts/ifcfg-eth0"),"\n";
print xmlencode("miitool",`/sbin/mii-tool 2>/dev/null`),"\n";
print xmlencodeFile("printcap","/etc/printcap"),"\n";
if (-x "/usr/bin/ntpstat")
  {
    print xmlencode("ntpstat",`/usr/bin/ntpstat`),"\n";
  }
elsif (-x "/usr/sbin/ntptrace")
  {
    print xmlencode("ntp",`/usr/sbin/ntptrace`),"\n";
  }
print xmlencode("mailspool",`/bin/ls -l /var/spool/mail`),"\n";
print xmlencode("ide",encodeIde()),"\n";
print encodeSmart();
print xmlencodeFile("scsi","/proc/scsi/scsi"),"\n";
print xmlencodeFile("etcnodeinfo","/etc/nodeinfo"),"\n";
print xmlencode("lspci",`/sbin/lspci`),"\n";
print xmlencodeFile("rootforward","/root/.forward"),"\n";
print xmlencodeFile("hostsallow","/etc/hosts.allow"),"\n";
print xmlencodeFile("hostsdeny", "/etc/hosts.deny"),"\n";
print xmlencodeFile("securenets","/var/yp/securenets"),"\n";
print xmlencodeFile("mdstat","/proc/mdstat"),"\n";
print encodeMD(),"\n";
print encodeEthtool(),"\n";
print xmlencode("netstatrn",`netstat -rn`),"\n";
print encodeBoot(),"\n";
print encodeYum(),"\n";
if (-r "/var/log/diskscrub.last.txt")
  {
    print xmlencode("diskscrub",`grep -v ^At /var/log/diskscrub.last.txt`),"\n";
  }
if (-r "/var/log/diskscrub.xml")
  {
    print "<diskscrubxml>\n",`cat /var/log/diskscrub.xml`,"</diskscrubxml>\n";
  }
print xmlencode("dmidecode",`/usr/sbin/dmidecode`),"\n" if (-r "/dev/mem") && (-x "/usr/sbin/dmidecode");
#print xmlencode("rpmnew",filterExistingFiles(`/usr/bin/locate rpmnew`)),"\n";
#print xmlencode("rpmsave",filterExistingFiles(`/usr/bin/locate rpmsave`)),"\n";
print xmlencode("rpms",`rpm -q -a | sort -u`),"\n";
print "</nodeinfo>\n";

exit 0;

sub xmlencodeFile
  {
    my $tag  = shift @_;
    my $file = shift @_;
    return if ! -e $file;
    open(TMPIN,$file) || return "";
    my $contents = join("",<TMPIN>);
    close TMPIN;
    $contents =~ s/\n$//;
    return xmlencode($tag,$contents);
  }

sub xmlencodeString
  {
    my $contents = join("",@_);
    $contents =~ s/\</&lt;/mg;
    $contents =~ s/\>/&gt;/mg;
    return $contents;
  }

sub xmlencode
  {
    my $tag = shift @_;
    my $contents = join("",@_);
    $contents =~ s/\n$//;
    $contents = xmlencodeString($contents);
    return "<$tag>$contents</$tag>";
  }

sub filterExistingFiles
  {
    my @e;
    foreach my $x (@_)
      {
        my @f = split(/\n/, $x);
        foreach my $f (@f)
          {
            push @e, $f if -e $f;
          }
      }
    return join("\n", @e);
  }

sub encodeIde24
  {
    my $ret = "";
    foreach my $drive (split(/\n/,`/bin/ls -1 /proc/ide`))
      {
	next if ! -r "/proc/ide/$drive/capacity";
	my $cap   = `cat /proc/ide/$drive/capacity`; chop $cap;
	my $model = `cat /proc/ide/$drive/model`; chop $model;
	my $cache = "none";
	if (-r "/proc/ide/$drive/cache")
	  {
	    $cache = `cat /proc/ide/$drive/cache`; chop $cache;
	  }
	$ret .= "$drive:$cap:$cache:$model\n";
      }
    return $ret;
  }

sub encodeIde26
  {
    my $ret = "";
    foreach my $drive (split(/\n/,`/bin/ls -1 /sys/block`))
      {
	next if ! -r "/sys/block/$drive/size";
        next if ($drive =~ /^ram/);
        next if ($drive =~ /^loop/);
	my $cap   = xreadline("/sys/block/$drive/size");
        $cap = 0 if ! defined $cap;
	my $model = xreadline("/sys/block/$drive/device/model");
	$model = xreadline("/proc/ide/$drive/model") if ! defined $model;
        $model = "(unknown)" if ! defined $model;
        my $removable = xreadline("/sys/block/$drive/removable");
        $cap = 0 if $removable;
	my $cache = xreadline("/proc/ide/$drive/cache");
        $cache = "none" if ! defined $cache;
        next if ($removable==0)&&($cap==0);
	$ret .= "$drive:$cap:$cache:$model";
        $ret .= " (removable)" if $removable;
        $ret .= "\n";
      }
    return $ret;
  }

sub encodeIde
  {
    return encodeIde26() if -r "/sys/block";
    return encodeIde24();
  }

sub encodeYum
  {
    my $xml = "";
    $xml .= "<yum>\n";
    
    $xml .= xmlencodeFile("yumconf", "/etc/yum.conf");
    $xml .= "\n";

    $xml .= "<repos>\n";
    foreach my $repo (sort split(/\n/, `/bin/ls -1 /etc/yum.repos.d`))
      {
        $xml .= "<repo file=\"$repo\">\n";
        $xml .= xmlencodeString(`cat /etc/yum.repos.d/$repo`);
        $xml .= "</repo>\n";
      }
    $xml .= "</repos>\n";

    $xml .= "<yumautoupdate>\n";
    $xml .= `/bin/ls -l /etc/cron.hourly/yum-autoupdate 2>&1`;
    $xml .= `/bin/ls -l /usr/sbin/yum-autoupdate 2>&1`;
    $xml .= `/bin/ls -l /etc/init.d/yum-autoupdate 2>&1`;
    $xml .= `/bin/ls -l /var/lock/subsys/yum-autoupdate 2>&1`;
    $xml .= "</yumautoupdate>\n";

    $xml .= "<yumautoupdate2>\n";
    $xml .= `/bin/ls -l /etc/cron.daily/yum-autoupdate 2>&1`;
    $xml .= `/bin/ls -l /etc/sysconfig/yum-autoupdate 2>&1`;
    $xml .= "</yumautoupdate2>\n";

    if (-r "/etc/sysconfig/yum-autoupdate") {
      $xml .= xmlencodeFile("yumautoupdate2sysconfig", "/etc/sysconfig/yum-autoupdate") . "\n";
    }

    $xml .= "<yumdotcron>\n";
    $xml .= `/bin/ls -l /etc/cron.d/yum.cron 2>&1`;
    $xml .= `/bin/ls -l /usr/sbin/yum.cron 2>&1`;
    $xml .= `/bin/ls -l /etc/init.d/yum 2>&1`;
    $xml .= `/bin/ls -l /var/lock/subsys/yum 2>&1`;
    $xml .= "</yumdotcron>\n";

    $xml .= "<yumdashcron>\n";
    $xml .= `/bin/ls -l /etc/cron.daily/yum-cron 2>&1`;
    $xml .= `/bin/ls -l /etc/cron.daily/0yum.cron 2>&1`;
    $xml .= `/bin/ls -l /etc/cron.weekly/yum-cron 2>&1`;
    $xml .= `/bin/ls -l /etc/rc.d/init.d/yum-cron 2>&1`;
    $xml .= `/bin/ls -l /etc/sysconfig/yum-cron 2>&1`;
    $xml .= `/bin/ls -l /etc/yum/yum-daily.yum 2>&1`;
    $xml .= `/bin/ls -l /var/lock/subsys/yum-cron 2>&1`;
    $xml .= "</yumdashcron>\n";

    $xml .= "</yum>\n";

    #print $xml;
    #die "Here!";

    return $xml;
  }

sub encodeBoot1
  {
    my $dev = shift @_;
    return `dd if=/dev/$dev bs=1 count=1024 2>&1 | strings`;
  }

sub encodeBoot
  {
    return "" if ! -r "/sys/block";
    my $xml = "";
    $xml .= "<boot>\n";

    my $names = "";

    opendir(DIR,"/sys/block");
    while (my $f = readdir(DIR))
      {
        next if $f =~ /^\./;
        next if $f =~ /^ram/;
        #print "$f\n";

        $xml .= "<$f>\n";
        $xml .= encodeBoot1($f);

        $names .= "$f\n";

        my $parts = "";

        opendir(DIR1,"/sys/block/$f");
        while (my $f1 = readdir(DIR1))
          {
            next unless $f1 =~ /^$f/;
            #print "$f1\n";

            $xml .= "<$f1>\n";
            $xml .= encodeBoot1($f1);
            $xml .= "</$f1>\n";

            $parts .= "$f1\n";
          }

        $xml .= "<partitions>\n$parts</partitions>\n" if length $parts > 1;
        $xml .= "</$f>\n";
      }

    $xml .= "<names>\n$names</names>\n";

    $xml .= "</boot>\n";

    #print $xml;
    #die "Here!";

    return $xml;
  }

sub encodeEthtool
  {
    return "" if ! -r "/sys/class/net";
    my $xml = "";
    $xml .= "<ethtool>\n";

    my $names = "";

    opendir(DIR,"/sys/class/net");
    while (my $f = readdir(DIR))
      {
        next unless $f =~ /^(eth\d+)$/;
        #print "$f\n";

        $xml .= xmlencode($f, `/sbin/ethtool $f 2>&1`."\n")."\n";
        $xml .= xmlencode($f."-i", `/sbin/ethtool -i $f 2>&1`."\n")."\n";

        $names .= "$f\n";
      }

    $xml .= "<names>\n$names</names>\n";

    $xml .= "</ethtool>\n";

    #print $xml;
    #die "Here!";

    return $xml;
  }

sub encodeMD
  {
    return "" if ! -r "/sys/block";
    my $xml = "";
    $xml .= "<md>\n";

    my $names = "";

    opendir(DIR,"/sys/block");
    while (my $f = readdir(DIR))
      {
        next unless $f =~ /^(md\d+)$/;
        #print "$f\n";

        $xml .= "<$f>\n";
        $xml .= xmlencodeFile("size", "/sys/block/$f/size") . "\n";

        if (-d "/sys/block/$f/md")
          {
            $xml .= xmlencodeFile("array_state", "/sys/block/$f/md/array_state") . "\n";
            #$xml .= xmlencodeFile("bitmap_set_bits", "/sys/block/$f/md/bitmap_set_bits") . "\n";
            $xml .= xmlencodeFile("component_size", "/sys/block/$f/md/component_size") . "\n";
            $xml .= xmlencodeFile("level", "/sys/block/$f/md/level") . "\n";
            if (-r "/sys/block/$f/md/mismatch_cnt") {
              $xml .= xmlencodeFile("mismatch_cnt", "/sys/block/$f/md/mismatch_cnt") . "\n";
            }
            if (-r "/sys/block/$f/md/degraded") {
              $xml .= xmlencodeFile("degraded", "/sys/block/$f/md/degraded") . "\n";
            }
            if (-r "/sys/block/$f/md/bitmap_set_bits") {
              $xml .= "<bitmap_set_bits/>" . "\n";
            }
          }

        $xml .= "</$f>\n";

        $names .= "$f\n";
      }

    $xml .= "<names>\n$names</names>\n";

    $xml .= "</md>\n";

    return $xml;
  }

sub encodeSmart
  {
    my $smartctl = "/usr/sbin/smartctl";

    return "" if ! -x $smartctl;

    my $xml = "";

    $xml .= "<smart>\n";

    if (-d "/sys/block")
      {
        opendir(DIR,"/sys/block");
        while (my $f = readdir(DIR))
          {
            my $dev = "/dev/$f";
            next unless -r $dev;
            next if -d $dev;
            #print "$dev\n";

            my $data = getsmart($smartctl,$dev);
            next unless $data;

            #print "\n\n\n$dev\n$data\n\n\n";
            #die "Here!";

            $xml .= "<data dev=\"$dev\">\n".$data."</data>\n";
          }
        closedir(DIR);

        #die "Here!";
      }
    else
      {
        foreach my $dev ("/dev/hda", "/dev/hdb", "/dev/hdc", "/dev/hdd")
          {
            next if ! -r $dev;

            my $data = getsmart($smartctl,$dev);
            next unless $data;
            
            $xml .= "<data dev=\"$dev\">\n".$data."</data>\n";
          }
      }

    if (`/sbin/lspci` =~ /3ware/)
      {
        my $dev = "/dev/twe0";

        print "Please create 3ware control device: mknod /dev/twe0 c 254 0\n" unless -r $dev;

        for (my $unit=0; $unit<=16; $unit++)
          {
            my $data = `$smartctl --device=3ware,$unit -a $dev 2>&1`;
            
            next if ! ($data =~ /SMART support is: Available/);
            
            $xml .= "<data dev=\"3ware/$unit\">\n".$data."</data>\n";
          }
      }
    
    $xml .= "</smart>\n";

    return $xml;
  }

sub getsmart
  {
    my $smartctl = shift @_;
    my $dev = shift @_;

    my $data = `$smartctl -a $dev 2>&1`;

    return if ($data =~ /please specify device type/); # smartctl does not know what this is.

    if ($data =~ /SATA disks accessed/)
      {
        $smartctl .= " -d ata";
        $data = `$smartctl -a $dev 2>&1`;
      }

    if ($data =~ /Use option -e to enable/)
      {
        system "$smartctl -e $dev >/dev/null 2>&1";
        $data = `$smartctl -a $dev 2>&1`;
      }

    if ($data =~ /Use option -s with argument 'on' to enable it/)
      {
        system "$smartctl -s on $dev >/dev/null 2>&1";
        $data = `$smartctl -a $dev 2>&1`;
      }
    
    # check return values from RHL8.0-9 smartctl
    return if $data =~ /No such device or address/; # no device
    return if $data =~ /Read-only file system/; # probably a CDROM
    return if $data =~ /Drive does not support/; # probably a CDROM
    return if $data =~ /SMART support is: Unavailable/; # probably a CDROM
    return if $data =~ /A mandatory SMART command failed/; # sorry, no SMART support
    
    # check return values from Fedora-1 smartctl
    #if ($data =~ /-T permissive/)
    #  {
    #    $data = `$smartctl -T permissive -a $dev 2>&1`;
    #  }
    
    return if $data =~ /No such device/; # no device
    return if $data =~ /SMART support is: Unavailable/; # CDROM

    return $data;
}

sub xreadfile
  {
    my $filename = shift @_;
    open (TMPIN,$filename) || return;
    my $v = <TMPIN>;
    close TMPIN;
    return $v;
  }

sub xreadline
  {
    my $val = xreadfile(shift @_);
    return if ! defined $val;
    $val =~ s/\n+$//;
    return $val;
  }

#end file
